function love.load()
love.window.setTitle("Snake Game")
gridXCount = 20
gridYCount = 15

eat = love.audio.newSource('sounds/apple_eaten.wav', 'static')
tick = love.audio.newSource('sounds/bop.wav', 'static')
die = love.audio.newSource('sounds/dead.wav','static')

function moveFood()
	
	local possibleFoodPos = {}
		for foodX = 1, gridXCount do
			for foodY = 1, gridYCount do
				local possible = true

				for segmentIndex, segment in ipairs(snakeSegments) do
					if foodX == segment.x and foodY == segment.y then
						possible = false
					end
				end

				if possible then
					table.insert(possibleFoodPos, {x = foodX, y = foodY})
				end
			end
		end

		foodPos= possibleFoodPos[
			love.math.random(#possibleFoodPos)
		]
	love.audio.play(eat)
end

	function reset()
		snakeSegments = {
		{x = 3, y = 1},
		{x = 2, y = 1},
		{x = 1, y = 1},
		}
		directionQueue = {'right'}
		snakeAlive = true
		timer = 0
		moveFood()
	end

	reset()
end



function love.update(dt)
	timer = timer + dt 

	if snakeAlive then	
		if timer >= 0.15 then 
			timer = 0

		if #directionQueue > 1 then
	            table.remove(directionQueue, 1)
	    end

	        local newXpos = snakeSegments[1].x 
			local newYpos = snakeSegments[1].y
	   
			if directionQueue[1] == 'right' then
				newXpos = newXpos + 1
				if newXpos > gridXCount then
	                newXpos = 1
	            end
			elseif directionQueue[1] == 'left' then
				newXpos = newXpos - 1
				if newXpos < 1 then
	               newXpos = gridXCount
	            end
	        elseif directionQueue[1] == 'down' then
				newYpos = newYpos + 1
				if newYpos > gridYCount then
	            	newYpos = 1
	            end
			elseif directionQueue[1] == 'up' then
				newYpos = newYpos - 1
				if newYpos < 1 then
	                newYpos = gridYCount
	            end
			end	

		
			local canMove = true

			for segmentIndex, segment in ipairs(snakeSegments) do
				if segmentIndex ~= #snakeSegments
				and nextXPos == segment.x
				and nextYpos == segment.y then
					canMove = false
				end
			end

			if canMove then
				table.insert(snakeSegments, 1,{
				x = newXpos, y = newYpos
				})

				if snakeSegments[1].x == foodPos.x
				and snakeSegments[1].y == foodPos.y then
					 moveFood()
				else
					table.remove(snakeSegments)	
				end
			else
				snakeAlive = false
			end
		end		
	elseif timer >= 2 then
			reset()
		end
	end			

	




function love.keypressed(key) --actual movement
--direction
    if key == 'right'
     and directionQueue[#directionQueue] ~= 'right'
     and directionQueue[#directionQueue] ~= 'left' then
        table.insert(directionQueue, 'right')
	elseif key == 'left' 
    and directionQueue[#directionQueue] ~= 'left'
    and directionQueue[#directionQueue] ~= 'right'  then
        table.insert(directionQueue, 'left')

    elseif key == 'up' 
    and directionQueue[#directionQueue] ~= 'up'
    and directionQueue[#directionQueue] ~= 'down'  then
        table.insert(directionQueue, 'up')

    elseif key == 'down'
    and directionQueue[#directionQueue] ~= 'down'   
    and directionQueue[#directionQueue] ~= 'up' then
        table.insert(directionQueue, 'down')
    end
end


function love.draw()
--draw the graphics

	
	local cellSize = 15


	

	love.graphics.setColor(.28, .28, 40)
	love.graphics.rectangle('fill', 0,0, 
		gridXCount * cellSize, gridYCount * cellSize)

	local function drawCell(x, y)
	love.graphics.rectangle(
		'fill',
		(x-1) * cellSize,
		(y-1) * cellSize,
		cellSize - 1,
		cellSize - 1
)
	end

--hh
for segmentIndex, segment in ipairs(snakeSegments) do --how the snake looks
	if snakeAlive then

		love.graphics.setColor(0, 1, .40)
	else
		love.graphics.setColor(.5,.5,.5)
	end
		drawCell(segment.x, segment.y)
end

	
	love.graphics.setColor(1, .3, .3)
	drawCell(foodPos.x, foodPos.y)

end